#include <WindowsConstants.au3>
#include <StaticConstants.au3>
#include <GUIConstantsEx.au3>
#include <String.au3>
#include <IE.au3>
#include <WinAPI.au3>

_IELoadWaitTimeout(3000)

Opt("WinTitleMatchMode",2)

Opt("ExpandEnvStrings",1)
Opt("ExpandVarStrings",1)

Opt("GUIOnEventMode", 1)

	
; ========== Name der INI-Datei holen

If $CmdLine[0]     > 0 Then
   $ToolTip        = $CmdLine[1]
   $INIDatei       = StringUpper($CmdLine[1])
Else
   $ToolTip        = "MiniBrowser.ini"
   $INIDatei       = "MINIBROWSER.INI"
EndIf


If not FileExists($INIDatei) Then
  MsgBox(0,"Mini-Browser",$CmdLine[1] & " nicht gefunden!")
  $INISchreiben    = 0
  Exit
Else
  $INISchreiben    = 1
EndIf

; ========== Der andern Instanz Befehle senden

If $CmdLine[0]     > 1 Then

  $SelberStarten       = 0

  ; Es wurde ganz kurz hintereinander ein Befehl gesendet
  If WinExists("Set" & $INIDatei) Then
    $WarteTimer      = TimerInit()
    While WinExists("Set" & $INIDatei) and TimerDiff($WarteTimer < 1500)
      Sleep(100)
    WEnd
    ; Hnger
    If WinExists("Set" & $INIDatei) Then
      WinKill("Set" & $INIDatei)
      If StringUpper($CmdLine[2]) = "WEITERMACHEN" or StringUpper($CmdLine[2]) = "AKTUALISIEREN" Then
        $SelberStarten   = 1
      Endif
    Endif
  Endif

  If StringUpper($CmdLine[2]) = "STOP" Then
    If WinExists($INIDatei & "Hauptfenster") Then
      WinSetTitle($INIDatei & "Hauptfenster","","Set" & $INIDatei & "Stop")
    EndIf
  EndIf

  If StringUpper($CmdLine[2]) = "PAUSE" Then
    If WinExists($INIDatei & "Hauptfenster") Then
      WinSetTitle($INIDatei & "Hauptfenster","","Set" & $INIDatei & "Pause")
    EndIf
  EndIf

  If StringUpper($CmdLine[2]) = "WEITERMACHEN" Then
    If WinExists($INIDatei & "Hauptfenster") Then
      WinSetTitle($INIDatei & "Hauptfenster","","Set" & $INIDatei & "Weitermachen")
    Else
      $SelberStarten   = 1
    EndIf
  EndIf

  If StringUpper($CmdLine[2]) = "AKTUALISIEREN" Then
    If WinExists($INIDatei & "Hauptfenster") Then
      WinSetTitle($INIDatei & "Hauptfenster","","Set" & $INIDatei & "Aktualisieren")
    Else
      $SelberStarten   = 1
    EndIf
  EndIf

  If $SelberStarten    = 0 Then
    $INISchreiben      = 0
    Exit
  EndIf

EndIf


; =========Prfen, ob Browser mit dieser INI schon luft

$FensterName           = $INIDatei & "DasWarTSAsIdee"

If WinExists($FensterName) Then
  MsGBox(0,"Mini-Browser","Programm kann nicht 2 x mit gleicher INI gestartet werden",3)
  $INISchreiben        = 0
  Exit
EndIf


AutoItWinSetTitle($INIDatei & "Hauptfenster")


; ========== Tray-Men erstellen

#NoTrayIcon

Opt("TrayOnEventMode",1)
Opt("TrayMenuMode",3)

$Pause    = TrayCreateItem("Pausieren ein/aus")
TrayItemSetOnEvent(-1,"Pausieren")
TrayItemSetState(-1,68)

$Springen = TrayCreateItem("Springen ein/aus")
TrayItemSetOnEvent(-1,"Springen")
TrayItemSetState(-1,1)

$Anpassen = TrayCreateItem("Ausschnitt anpassen")
TrayItemSetOnEvent(-1,"Anpassen")
TrayItemSetState(-1,68)

$Position = TrayCreateItem("Browser-Position zuweisen")
TrayItemSetOnEvent(-1,"Position")

TrayCreateItem("Beenden")
TrayItemSetOnEvent(-1,"Beenden")

TraySetState()

TraySetToolTip(StringTrimRight($Tooltip,4))


; ========== Laden der Variablen

$URL                              = IniRead($INIDatei,"Einstellungen","URL"                        ,"http://www.wetter.zdf.de/CMO/frontend/subsystem_we/WeShowPicture/0,6008,161,00.gif")

$MausLinksPfad                    = IniRead($INIDatei,"Einstellungen","MausLinksPfad"              ,"")
$MausLinksDatei                   = IniRead($INIDatei,"Einstellungen","MausLinksDatei"             ,"")
$MausLinksParameter               = IniRead($INIDatei,"Einstellungen","MausLinksParameter"         ,"")
$MausLinksModus                   = IniRead($INIDatei,"Einstellungen","MausLinksModus"             ,"")

$MausRechtsPfad                   = IniRead($INIDatei,"Einstellungen","MausRechtsPfad"             ,"")
$MausRechtsDatei                  = IniRead($INIDatei,"Einstellungen","MausRechtsDatei"            ,"")
$MausRechtsParameter              = IniRead($INIDatei,"Einstellungen","MausRechtsParameter"        ,"")
$MausRechtsModus                  = IniRead($INIDatei,"Einstellungen","MausRechtsModus"            ,"")

$MausDoppelPfad                   = IniRead($INIDatei,"Einstellungen","MausDoppelPfad"             ,"")
$MausDoppelDatei                  = IniRead($INIDatei,"Einstellungen","MausDoppelDatei"            ,"")
$MausDoppelParameter              = IniRead($INIDatei,"Einstellungen","MausDoppelParameter"        ,"")
$MausDoppelModus                  = IniRead($INIDatei,"Einstellungen","MausDoppelModus"            ,"")

$AbstandLinks                     = IniRead($INIDatei,"Einstellungen","AbstandLinks"               ,200)
$AbstandOben                      = IniRead($INIDatei,"Einstellungen","AbstandOben"                ,200)

$FensterBreit                     = IniRead($INIDatei,"Einstellungen","FensterBreit"               ,210)
$FensterHoch                      = IniRead($INIDatei,"Einstellungen","FensterHoch"                ,247)

$AbschneidenLinks                 = IniRead($INIDatei,"Einstellungen","AbschneidenLinks"           ,141)
$AbschneidenOben                  = IniRead($INIDatei,"Einstellungen","AbschneidenOben"            ,40)

$BrowserBreit                     = IniRead($INIDatei,"Einstellungen","BrowserBreit"               ,"Standard")
$BrowserHoch                      = IniRead($INIDatei,"Einstellungen","BrowserHoch"                ,"Standard")

$AktualisierungMinuten            = IniRead($INIDatei,"Einstellungen","AktualisierungMinuten"      ,15)
$AktualisierungErzwingen          = IniRead($INIDatei,"Einstellungen","AktualisierungErzwingen"    ,0)

$Transparenz                      = IniRead($INIDatei,"Einstellungen","Transparenz"                ,0)

$TransparenzHintergrund           = IniRead($INIDatei,"Einstellungen","TransparenzHintergrund"     ,0)

$GeschwindigkeitAusblenden        = IniRead($INIDatei,"Einstellungen","GeschwindigkeitAusblenden"  ,100)
$GeschwindigkeitEinblenden        = IniRead($INIDatei,"Einstellungen","GeschwindigkeitEinblenden"  ,100)

$TopVordergrund                   = IniRead($INIDatei,"Einstellungen","TopVordergrund"             ,0)

$FensterA                         = _StringExplode(IniRead($INIDatei,"Einstellungen","FensterA",""),"/")
$FensterB                         = _StringExplode(IniRead($INIDatei,"Einstellungen","FensterB",""),"/")
$FensterC                         = _StringExplode(IniRead($INIDatei,"Einstellungen","FensterC",""),"/")
$FensterD                         = _StringExplode(IniRead($INIDatei,"Einstellungen","FensterD",""),"/")
$FensterE                         = _StringExplode(IniRead($INIDatei,"Einstellungen","FensterE",""),"/")
$FensterF                         = _StringExplode(IniRead($INIDatei,"Einstellungen","FensterF",""),"/")
$FensterG                         = _StringExplode(IniRead($INIDatei,"Einstellungen","FensterG",""),"/")
$FensterH                         = _StringExplode(IniRead($INIDatei,"Einstellungen","FensterH",""),"/")
$FensterI                         = _StringExplode(IniRead($INIDatei,"Einstellungen","FensterI",""),"/")
$FensterJ                         = _StringExplode(IniRead($INIDatei,"Einstellungen","FensterJ",""),"/")

$PausierenWennAnderesFenster      = IniRead($INIDatei,"Einstellungen","PausierenWennAnderesFenster",0)


; ======== System-Variablen

If $BrowserBreit < 1 Then
  $BrowserBreit  = @DesktopWidth
EndIf

If $BrowserHoch  < 1 Then
  $BrowserHoch   = 5000            ; 5000 verhindert das vertikale Scrollen
EndIf

$Positionieren                    = 1
$PositionierenAlt                 = 1

$Pausieren                        = 0

$LetztesFenster                   = $FensterName

$Gefunden                         = 0

$Sekunden                         = 0

If $GeschwindigkeitEinblenden > 0 and $GeschwindigkeitEinblenden <= 100 Then
  $Alpha                          = 0
  $Ausgeblendet                   = 1
Else
  $Alpha                          = 255 - $Transparenz
  $Ausgeblendet                   = 0                    ; sonst wird gar nichts angezeigt, wenn kein Einblenden gewnscht
EndIf

If $MausLinksDatei <> "" or $MausRechtsDatei <> "" or $MausDoppelDatei <> "" Then
  $MausBefehle                    = 1
Else
  $MausBefehle                    = 0
EndIf

If StringInStr($URL,"http:") > 0 or StringInStr($URL,"www.") > 0 Then
  $IstWebSeite                    = 1
  If $MausDoppelDatei             = "" Then
    $MausDoppelDatei              = $URL
  EndIf
Else
  $IstWebSeite                    = 0
EndIf


; ========== GUI initialisieren

$hGUI = GUICreate($FensterName,$FensterBreit,$FensterHoch,$AbstandLinks,$AbstandOben,BitOR($WS_POPUP,$WS_CLIPSIBLINGS, $WS_CLIPCHILDREN),BitOR($WS_EX_LAYERED,$WS_EX_TOPMOST,$WS_EX_TOOLWINDOW))

If $TransparenzHintergrund = 1 Then
  DllCall("user32.dll","int","SetLayeredWindowAttributes","hWnd",$hGUI,"long","0xFFFFFF","byte",$Alpha,"long",0x3)
Else
  DllCall("user32.dll","int","SetLayeredWindowAttributes","hWnd",$hGUI,"long","0xFFFFFF","byte",$Alpha,"long",0x2)
EndIf


If $IstWebSeite   = 1 and $MausBefehle = 0 Then 
  $Labels         = GUICtrlCreateLabel("",0,0,30,30,$SS_CENTER,$GUI_WS_EX_PARENTDRAG) ; damit der Ausschnitt an der linken oberen Ecke verschoben werden kann
  $URLTimer       = TimerInit()
  GUISetOnEvent($GUI_EVENT_PRIMARYDOWN,"URLStarten",$hGUI)
Else
  $Labels         = GUICtrlCreateLabel("",0,0,$FensterBreit,$FensterHoch,$SS_CENTER,$GUI_WS_EX_PARENTDRAG)
  If $MausBefehle = 1 Then
    $MausTimer    = TimerInit()
    GUICtrlSetOnEvent(-1,"MausLinks")
    GUISetOnEvent($GUI_EVENT_SECONDARYUP,"MausRechts",$hGUI)
  EndIf
EndIf

GUISetState()

$FensterPos              = WinGetPos($FensterName) ; sonst kommt Fehlermeldung, wenn Fenster sofort nach Start verschoben wird


; ========== Browser-Fenster initialisieren

$oIE = _IECreateEmbedded()

$Browser  = GUICtrlCreateObj($oIE,-$AbschneidenLinks,-$AbschneidenOben,$BrowserBreit,$BrowserHoch)

_IENavigate($oIE,$URL)

Einblenden()

; ========== Endlos-Schleife, welche das Springen erlaubt und das Bild im gewnschten Intervall aktualisiert

While True

   Sleep(1000)

   If AutoItWinGetTitle()<> $INIDatei & "Hauptfenster" Then BefehlAusfuehren()

   If $Pausieren          = 1 Then ContinueLoop

   ; ======= Ev. Fenster verschieben, wenn anderes Fenster aktiv

   $AktivesFenster        = _WinAPI_GetWindowText(_WinAPI_GetForegroundWindow())

   $Geaendert             = 0

   FensterListe()

   If $Geaendert          = 1 Then

     If $Positionieren    = 1 Then FensterVerschieben()

     If $Positionieren    = 1 and $PausierenWennAnderesFenster = 1 Then VielleichtSchlafen()

   EndIf

   ; Browser im gewnschten Zeitintervall aktualisieren

   $Sekunden              = $Sekunden + 1
   If $Sekunden          >= $AktualisierungMinuten * 60 and $AktualisierungMinuten >= 1 Then
     If $Ausgeblendet     = 0 Then  ; Nur Aktualisieren, wenn eingeblendet
       Aktualisieren()
     EndIf
   EndIf

   ; ======= Anzeige auch vor andere "immer im Vordergrund Fenster" hervorholen

   If $TopVordergrund       = 1 Then WinSetOnTop($FensterName,"",1)

   ; ======= Damit Positionen beim Beenden zur Verfgung stehen

   $FensterPos              = WinGetPos($FensterName) 

   ; Jede Minute in Erinnerung rufen, "dass Ausschnitt anpassen" aktiv ist!

   If TrayItemGetState($Anpassen) = 65 and not WinActive($FensterName) and @SEC = 0 Then
     WinActivate($FensterName)
     TrayTip ("Achtung","Anpassen aktiv",1,2)
   EndIf

WEnd



; ========== Funktionen ======================================================================


; ========== Fenster-Liste (Ausnahmen)

Func FensterListe()

If $AktivesFenster   = "" and $LetztesFenster <> "Browser-Dummy" Then ; z.B. Bildschirmschoner
  If not WinExists($LetztesFenster) or BitAnd(WinGetState($LetztesFenster),16)  Then
    $AktivesFenster  = "Browser-Dummy" ; er wird schlafen gehen
    $LetztesFenster  = "Browser-Dummy"
    $Geaendert       = 1
    Return
  EndIf
EndIf

If $AktivesFenster   = ""                            Then $AktivesFenster = "Browser-Dummy"
If $AktivesFenster   = "Browser-Dummy"               Then return
If $AktivesFenster   = $LetztesFenster               Then return
If $AktivesFenster   = "Screen Saver"                Then return
If $AktivesFenster   = "Zeiger"                      Then return
If $AktivesFenster   = "Labels"                      Then return
If $AktivesFenster   = "Analoge Uhr"                 Then return
If $AktivesFenster   = "Windows Task-Manager"        Then return
If $AktivesFenster   = "Digitale Uhr"                Then return
If $AktivesFenster   = "Programmumschaltung"         Then return
If StringInStr($AktivesFenster,"DasWarTSAsIdee") > 0 Then return
If StringInStr($AktivesFenster,"Hauptfenster")   > 0 Then return

$LetztesFenster      = $AktivesFenster
$Geaendert           = 1

EndFunc


; ========== Vielleicht schlafen

Func VielleichtSchlafen()


$Gefunden = 0

If UBound($FensterA) = 3 and WinActive($FensterA[0])     = 1 Then $Gefunden = 1
If UBound($FensterB) = 3 and WinActive($FensterB[0])     = 1 Then $Gefunden = 1
If UBound($FensterC) = 3 and WinActive($FensterC[0])     = 1 Then $Gefunden = 1
If UBound($FensterD) = 3 and WinActive($FensterD[0])     = 1 Then $Gefunden = 1
If UBound($FensterE) = 3 and WinActive($FensterE[0])     = 1 Then $Gefunden = 1
If UBound($FensterF) = 3 and WinActive($FensterF[0])     = 1 Then $Gefunden = 1
If UBound($FensterG) = 3 and WinActive($FensterG[0])     = 1 Then $Gefunden = 1
If UBound($FensterH) = 3 and WinActive($FensterH[0])     = 1 Then $Gefunden = 1
If UBound($FensterI) = 3 and WinActive($FensterI[0])     = 1 Then $Gefunden = 1
If UBound($FensterJ) = 3 and WinActive($FensterJ[0])     = 1 Then $Gefunden = 1

Schlafen()

EndFunc


; ========== Fenster verschieben

Func FensterVerschieben()

If UBound($FensterA)   = 3 and WinActive($FensterA[0])    = 1 Then WinMove($FensterName,"",$FensterA[1],$FensterA[2])
If UBound($FensterB)   = 3 and WinActive($FensterB[0])    = 1 Then WinMove($FensterName,"",$FensterB[1],$FensterB[2])
If UBound($FensterC)   = 3 and WinActive($FensterC[0])    = 1 Then WinMove($FensterName,"",$FensterC[1],$FensterC[2])
If UBound($FensterD)   = 3 and WinActive($FensterD[0])    = 1 Then WinMove($FensterName,"",$FensterD[1],$FensterD[2])
If UBound($FensterE)   = 3 and WinActive($FensterE[0])    = 1 Then WinMove($FensterName,"",$FensterE[1],$FensterE[2])
If UBound($FensterF)   = 3 and WinActive($FensterF[0])    = 1 Then WinMove($FensterName,"",$FensterF[1],$FensterF[2])
If UBound($FensterG)   = 3 and WinActive($FensterG[0])    = 1 Then WinMove($FensterName,"",$FensterG[1],$FensterG[2])
If UBound($FensterH)   = 3 and WinActive($FensterH[0])    = 1 Then WinMove($FensterName,"",$FensterH[1],$FensterH[2])
If UBound($FensterI)   = 3 and WinActive($FensterI[0])    = 1 Then WinMove($FensterName,"",$FensterI[1],$FensterI[2])
If UBound($FensterJ)   = 3 and WinActive($FensterJ[0])    = 1 Then WinMove($FensterName,"",$FensterJ[1],$FensterJ[2])

EndFunc


; ========== Pausieren

Func Pausieren()

  If TrayItemGetState($Pause) = 68 Then
    TrayItemSetState($Pause,65)
    Ausblenden()
    WinSetState($FensterName,"",@SW_HIDE)
    $Ausgeblendet             = 1  ; auch hier ntig, damit Fenster, bei Ausblenden 0 richtig geupdatet werden
    $PositionierenAlt         = $Positionieren
    $Positionieren            = 0
    $Pausieren                = 1
    TrayItemSetState($Springen,128)
    TrayItemSetState($Anpassen,128)
    TrayItemSetState($Position,128)
  Else
    TrayItemSetState($Pause,68)
    WinSetState($FensterName,"",@SW_SHOW)
    Einblenden()
    $Ausgeblendet             = 0  ; auch hier ntig, damit Fenster, bei Einblendeen 0 richtig geupdatet werden
    $Positionieren            = $PositionierenAlt
    $Pausieren                = 0
    $Sekunden                 = 60 * $AktualisierungMinuten - 3
    TrayItemSetState($Springen,64)
    TrayItemSetState($Anpassen,64)
    TrayItemSetState($Position,64)
  EndIf

EndFunc


; ========== Springen aktivieren/deaktivieren

Func Springen()

  If TrayItemGetState($Springen) = 68 Then
    TrayItemSetState($Springen,65)
    $Positionieren            = 1
  Else
    TrayItemSetState($Springen,68)
    $Positionieren            = 0
  EndIf

EndFunc


; ========== Position anzeigen / in Zwischenablage kopieren

Func Position()

; Zuerst das Springen ausschalten

$SpringenAlt            = TrayItemGetState($Springen)
$PositionierenVorher    = $Positionieren

TrayItemSetState($Springen,68)
$Positionieren          = 0

If $LetztesFenster = $FensterName or $LetztesFenster = "BrowserDummy" Then
   MsgBox(262144,"ACHTUNG","Zuerst das Fenster aktivieren," & @LF & "zu welchem die Position gespeichert werden soll!",5)
   sleep(2000)
   $LetztesFenster      = WinGetTitle("[Active]")
EndIf

$FensterPos             = WinGetPos($FensterName)
$XP                     = $FensterPos[0]
$YP                     = $FensterPos[1]

$PosString              = $LetztesFenster & "/" & $XP & "/" & $YP

ClipPut($PosString)

; WinWaitActive() und WinSetOnTop() scheinen casesensitive zu sein!
$Pfad                   = @ScriptDir & "\"
$EditorTitel            = FileGetLongName($Pfad & $INIDatei)    ; Dateinamen mit richtiger Gross-/Kleinschreibung holen
$EditorTitel            = StringReplace($EditorTitel,$Pfad,"")  ; Pfad abschneiden

Run("Notepad.exe " & $EditorTitel)

$PunktPosition          = StringInStr($EditorTitel,".")         ;Datei-Erweiterung abschneiden, weil diese je nach Einstellung im Explorer nicht angezeigt wird
$EditorTitel            = StringLeft($EditorTitel,$PunktPosition-1)

$MomentanAktiv          = _WinAPI_GetWindowText(_WinAPI_GetForegroundWindow())
$Abwarten               = TimerInit()

While TimerDiff($Abwarten) < 3000

  Sleep(100)
  $MomentanAktiv        = _WinAPI_GetWindowText(_WinAPI_GetForegroundWindow())

  If StringInStr($MomentanAktiv,$EditorTitel) > 0 and StringInStr($MomentanAktiv,"Editor") > 0 Then
    ExitLoop
  EndIf

WEnd

WinSetOnTop($MomentanAktiv,"",1)
Send("^{END}")

$AnzeigeText            = $PosString & @LF & "in Zwischenablage gespeichert" & @LF & @LF & "Bitte beim gewnschten Fenster einfgen," & @LF & "speichern und Editor schliessen"

MsgBox(262144,"Aktuelle Position des Browser-Fensters",$AnzeigeText)

; Springen zurcksetzen

TrayItemSetState($Springen,$SpringenAlt)
$Positionieren          = $PositionierenVorher

; Nach dem Schliessen des Editors Einstellungen neu laden

$Zaehler   = 0

While $Zaehler < 60
  Sleep(1000)
  $Zaehler = $Zaehler + 1
  If not WinExists($MomentanAktiv) Then
    ExitLoop
  EndIf
WEnd

$FensterA  = _StringExplode(IniRead($INIDatei,"Einstellungen","FensterA",""),"/")
$FensterB  = _StringExplode(IniRead($INIDatei,"Einstellungen","FensterB",""),"/")
$FensterC  = _StringExplode(IniRead($INIDatei,"Einstellungen","FensterC",""),"/")
$FensterD  = _StringExplode(IniRead($INIDatei,"Einstellungen","FensterD",""),"/")
$FensterE  = _StringExplode(IniRead($INIDatei,"Einstellungen","FensterE",""),"/")
$FensterF  = _StringExplode(IniRead($INIDatei,"Einstellungen","FensterF",""),"/")
$FensterG  = _StringExplode(IniRead($INIDatei,"Einstellungen","FensterG",""),"/")
$FensterH  = _StringExplode(IniRead($INIDatei,"Einstellungen","FensterH",""),"/")
$FensterI  = _StringExplode(IniRead($INIDatei,"Einstellungen","FensterI",""),"/")
$FensterJ  = _StringExplode(IniRead($INIDatei,"Einstellungen","FensterJ",""),"/")

$PausierenWennAnderesFenster = IniRead($INIDatei,"Einstellungen","PausierenWennAnderesFenster",0)

EndFunc


; ========== Schlafen, wenn keines der definierten Fenster aktiv ist

Func Schlafen()

If $Gefunden       = 0 Then
  Ausblenden()
  $Ausgeblendet    = 1  ; auch hier ntig, damit Fenster, bei Ausblenden 0 richtig geupdatet werden
  WinSetState($FensterName,"",@SW_HIDE)
Else
  WinSetState($FensterName,"",@SW_SHOW)
  Einblenden()
  $Ausgeblendet    = 0  ; auch hier ntig, damit Fenster, bei Einblenden 0 richtig geupdatet werden
EndIf

EndFunc


; ========== Ausblenden

Func Ausblenden()

If $Ausgeblendet = 1 Then return

If $GeschwindigkeitAusblenden > 100 or $GeschwindigkeitAusblenden = 0 Then

  $Alpha         = 0

  If $TransparenzHintergrund = 1 Then
    DllCall("user32.dll","int","SetLayeredWindowAttributes","hWnd",$hGUI,"long","0xFFFFFF","byte",$Alpha,"long",0x3)
  Else
    DllCall("user32.dll","int","SetLayeredWindowAttributes","hWnd",$hGUI,"long","0xFFFFFF","byte",$Alpha,"long",0x2)
  EndIf

  $Ausgeblendet  = 1

  Return

EndIf

$Geschwindigkeit   = 101 - $GeschwindigkeitAusblenden

$Schritte          = $Alpha/255*10

For $I = 255 to 0 Step -10

  $Alpha           = $Alpha - $Schritte

  if $Alpha        < 0 Then $Alpha = 0

  If $TransparenzHintergrund = 1 Then
    DllCall("user32.dll","int","SetLayeredWindowAttributes","hWnd",$hGUI,"long","0xFFFFFF","byte",$Alpha,"long",0x3)
  Else
    DllCall("user32.dll","int","SetLayeredWindowAttributes","hWnd",$hGUI,"long","0xFFFFFF","byte",$Alpha,"long",0x2)
  EndIf
 
  Sleep($Geschwindigkeit)

Next

$Ausgeblendet      = 1

EndFunc


; ========== Einblenden

Func Einblenden()

If $Ausgeblendet    = 0 Then return

;Wird sofort nach dem Einblenden aktualisiert, kommt es vereinzelt zu Fehlern
;Wenn mehrere MiniBrowser gleichzeitig aktualisiert werden mssen
If $Sekunden       >= $AktualisierungMinuten * 60 and $AktualisierungMinuten >= 1 Then
  $Sekunden         = $AktualisierungMinuten * 60 - 3
Endif

FensterVerschieben() ; damit es VOR dem Einblenden am richtigen Ort steht

If $GeschwindigkeitEinblenden > 100 or $GeschwindigkeitEinblenden = 0 Then

  $Alpha             = 255 - $Transparenz

  If $TransparenzHintergrund = 1 Then
    DllCall("user32.dll","int","SetLayeredWindowAttributes","hWnd",$hGUI,"long","0xFFFFFF","byte",$Alpha,"long",0x3)
  Else
    DllCall("user32.dll","int","SetLayeredWindowAttributes","hWnd",$hGUI,"long","0xFFFFFF","byte",$Alpha,"long",0x2)
  EndIf

  $Ausgeblendet      = 0

  Return

EndIf

$XAlpha            = 255 - $Transparenz

$Geschwindigkeit   = 101 - $GeschwindigkeitEinblenden

$Schritte          = $XAlpha/255*10

For $I = 255 to 0 Step -10

  $Alpha           = $Alpha + $Schritte

  if $Alpha        > 255 Then $Alpha = 255

  If $TransparenzHintergrund = 1 Then
    DllCall("user32.dll","int","SetLayeredWindowAttributes","hWnd",$hGUI,"long","0xFFFFFF","byte",$Alpha,"long",0x3)
  Else
    DllCall("user32.dll","int","SetLayeredWindowAttributes","hWnd",$hGUI,"long","0xFFFFFF","byte",$Alpha,"long",0x2)
  EndIf

  Sleep($Geschwindigkeit)

Next

; Damit es sicher stimmt wegen Rundungsdifferenzen
$Alpha             = 255 - $Transparenz

If $TransparenzHintergrund = 1 Then
  DllCall("user32.dll","int","SetLayeredWindowAttributes","hWnd",$hGUI,"long","0xFFFFFF","byte",$Alpha,"long",0x3)
Else
  DllCall("user32.dll","int","SetLayeredWindowAttributes","hWnd",$hGUI,"long","0xFFFFFF","byte",$Alpha,"long",0x2)
EndIf

$Ausgeblendet      = 0

EndFunc


; ========== Anpassen

Func Anpassen()

If TrayItemGetState($Anpassen) = 68 Then

  TrayItemSetText ($Anpassen,"Anpassen beenden")
  TrayItemSetState($Anpassen,65)

  TrayTip ("Achtung","Anpassen aktiv",1,2)
  TraySetState(4)

  HotKeySet("{Up}"     ,"ObenMehr")
  HotKeySet("{Down}"   ,"ObenWeniger")
  HotKeySet("{Left}"   ,"LinksMehr")
  HotKeySet("{Right}"  ,"LinksWeniger")

  HotKeySet("^{Up}"    ,"WenigerHoch")
  HotKeySet("^{Down}"  ,"Hoeher")
  HotKeySet("^{Left}"  ,"Schmaeler")
  HotKeySet("^{Right}" ,"Breiter")

  $AnzeigeText  = "Mit Pfeiltasten Ausschnitt verschieben" & @LF & @LF
  $AnzeigeText  = $AnzeigeText & "Mit Strg-Pfeiltasten Ausschnitt vergrssern/verkleinern"
  MsgBox(262144,"Ausschnitt anpassen",$AnzeigeText,5)

Else

  TrayItemSetText ($Anpassen,"Ausschnitt anpassen")
  TrayItemSetState($Anpassen,68)
  TrayTip ("","",0)
  TraySetState(8)

  HotKeySet("{Up}"   )
  HotKeySet("{Down}" )
  HotKeySet("{Left}" )
  HotKeySet("{Right}")

  HotKeySet("^{Up}"   )
  HotKeySet("^{Down}" )
  HotKeySet("^{Left}" )
  HotKeySet("^{Right}")

  $Antwort        = MsgBox(262148,"Ausschnitt anpassen","Neue Einstellungen speichern?")

  If $Antwort     = 6 Then ; JA

    IniWrite($INIDatei,"Einstellungen","FensterBreit"     ," "& $FensterBreit)
    IniWrite($INIDatei,"Einstellungen","FensterHoch"      ," "& $FensterHoch)
    IniWrite($INIDatei,"Einstellungen","AbschneidenLinks" ," "& $AbschneidenLinks)
    IniWrite($INIDatei,"Einstellungen","AbschneidenOben"  ," "& $AbschneidenOben)

  Else

    $FensterBreit      = IniRead($INIDatei,"Einstellungen","FensterBreit"     ,215)
    $FensterHoch       = IniRead($INIDatei,"Einstellungen","FensterHoch"      ,256)
    $AbschneidenLinks  = IniRead($INIDatei,"Einstellungen","AbschneidenLinks" ,126)
    $AbschneidenOben   = IniRead($INIDatei,"Einstellungen","AbschneidenOben"  ,15)

    WinMove($FensterName,"",$AbstandLinks,$AbstandOben,$FensterBreit,$FensterHoch)
    GUICtrlSetPos($Browser,-$AbschneidenLinks,-$AbschneidenOben,$BrowserBreit,$BrowserHoch)

  EndIf

EndIf

EndFunc


Func ObenMehr()

; Die Pfeiltasten knnen in keinem anderen Programm verwendet werden
; bis Anpassen wieder ausgeschaltet wird.

If not WinActive($FensterName) Then WinActivate($FensterName)

$AbschneidenOben  = $AbschneidenOben + 1

GUICtrlSetPos($Browser,-$AbschneidenLinks,-$AbschneidenOben)

EndFunc


Func ObenWeniger()

If not WinActive($FensterName) Then WinActivate($FensterName)

$AbschneidenOben  = $AbschneidenOben -1

GUICtrlSetPos($Browser,-$AbschneidenLinks,-$AbschneidenOben)


EndFunc


Func LinksMehr()

If not WinActive($FensterName) Then WinActivate($FensterName)

$AbschneidenLinks = $AbschneidenLinks +1

GUICtrlSetPos($Browser,-$AbschneidenLinks,-$AbschneidenOben)

EndFunc


Func LinksWeniger()

If not WinActive($FensterName) Then WinActivate($FensterName)

$AbschneidenLinks = $AbschneidenLinks -1

GUICtrlSetPos($Browser,-$AbschneidenLinks,-$AbschneidenOben)

EndFunc


Func WenigerHoch()

If not WinActive($FensterName) Then WinActivate($FensterName)

$AktPos           = WinGetPos($FensterName)
$AX               = $AktPos[0]
$AY               = $AktPos[1]

$FensterHoch      = $FensterHoch  - 1

WinMove($FensterName,"",$AX,$AY,$FensterBreit,$FensterHoch)

; Scheint ntig, damit nicht auch eine Verschiebung des Ausschnitts bewirkt wird
GUICtrlSetPos($Browser,-$AbschneidenLinks,-$AbschneidenOben,$BrowserBreit,$BrowserHoch)


EndFunc


Func Hoeher()

If not WinActive($FensterName) Then WinActivate($FensterName)

$AktPos           = WinGetPos($FensterName)
$AX               = $AktPos[0]
$AY               = $AktPos[1]

$FensterHoch      = $FensterHoch  + 1

WinMove($FensterName,"",$AX,$AY,$FensterBreit,$FensterHoch)

GUICtrlSetPos($Browser,-$AbschneidenLinks,-$AbschneidenOben,$BrowserBreit,$BrowserHoch)

EndFunc


Func Schmaeler()

If not WinActive($FensterName) Then WinActivate($FensterName)

$AktPos           = WinGetPos($FensterName)
$AX               = $AktPos[0]
$AY               = $AktPos[1]

$FensterBreit     = $FensterBreit  - 1

WinMove($FensterName,"",$AX,$AY,$FensterBreit,$FensterHoch)

GUICtrlSetPos($Browser,-$AbschneidenLinks,-$AbschneidenOben,$BrowserBreit,$BrowserHoch)

EndFunc


Func Breiter()

If not WinActive($FensterName) Then WinActivate($FensterName)

$AktPos           = WinGetPos($FensterName)
$AX               = $AktPos[0]
$AY               = $AktPos[1]

$FensterBreit     = $FensterBreit  + 1

WinMove($FensterName,"",$AX,$AY,$FensterBreit,$FensterHoch)

GUICtrlSetPos($Browser,-$AbschneidenLinks,-$AbschneidenOben,$BrowserBreit,$BrowserHoch)
	
EndFunc


; ========== URL starten

Func URLStarten()

If TrayItemGetState($Anpassen) = 65 Then
  return
EndIf

If TimerDiff($URLTimer)        < 600 Then           ; Doppelklick
  ShellExecute($URL,"","","",@SW_MAXIMIZE)
Else                                         ; Erster Klick
  $URLTimer                    = TimerInit()
EndIf

EndFunc


; ========== Mausklick links

Func MausLinks()

If TrayItemGetState($Anpassen) = 65 Then
  return
EndIf

$MausTimer                     = TimerInit()

Opt("GUIOnEventMode",0)
GUICtrlSetState($Labels,$GUI_HIDE)   ; Sonst erhlt die GUI im Modus 0 keine Nachrichten

While 1

 $Msg = GUIGetMsg()

 Select

   Case $Msg = $GUI_EVENT_PRIMARYDOWN
     ExitLoop

   Case TimerDiff($MausTimer)  > 600
     ExitLoop

 EndSelect

WEnd

Opt("GUIOnEventMode",1)
GUICtrlSetState($Labels,$GUI_SHOW)

$AktuellePos                   = WinGetPos($FensterName)

If $AktuellePos[0] <> $FensterPos[0] or $AktuellePos[1] <> $FensterPos[1] Then
   return
EndIf

if TimerDiff($MausTimer)      <= 600 Then
  DoppelKlick()
else
  LinksKlick()
endif

EndFunc


; ========== Mausklick rechts

Func MausRechts()

If TrayItemGetState($Anpassen) = 65 Then
  return
EndIf

Rechtsklick()

EndFunc


; ========== Linksklick

Func LinksKlick()

If $MausLinksDatei            = "" Then
  return
EndIf

$MausLinksModus               = StringUpper($MausLinksModus)

If $MausLinksModus            = "VERSTECKT" or $MausLinksModus = "MAXIMIERT" or $MausLinksModus = "NORMAL" Then

  If $MausLinksModus          = "VERSTECKT" Then
    ShellExecute($MausLinksDatei,$MausLinksParameter,$MausLinksPfad,"",@SW_HIDE)
  EndIf

  If $MausLinksModus          = "MAXIMIERT" Then
    ShellExecute($MausLinksDatei,$MausLinksParameter,$MausLinksPfad,"",@SW_MAXIMIZE)
  EndIf

  If $MausLinksModus          = "NORMAL" Then
    ShellExecute($MausLinksDatei,$MausLinksParameter,$MausLinksPfad)
  EndIf

Else

  ShellExecute($MausLinksDatei,$MausLinksParameter,$MausLinksPfad,"",@SW_MINIMIZE)

EndIf

EndFunc



; ========== Rechtsklick

Func RechtsKlick()

If $MausRechtsDatei           = "" Then
  return
EndIf

$MausRechtsModus              = StringUpper($MausRechtsModus)

If $MausRechtsModus           = "VERSTECKT" or $MausRechtsModus = "MAXIMIERT" or $MausRechtsModus = "NORMAL" Then

  If $MausRechtsModus         = "VERSTECKT" Then
    ShellExecute($MausRechtsDatei,$MausRechtsParameter,$MausRechtsPfad,"",@SW_HIDE)
  EndIf

  If $MausRechtsModus         = "MAXIMIERT" Then
    ShellExecute($MausRechtsDatei,$MausRechtsParameter,$MausRechtsPfad,"",@SW_MAXIMIZE)
  EndIf

  If $MausRechtsModus         = "NORMAL" Then
    ShellExecute($MausRechtsDatei,$MausRechtsParameter,$MausRechtsPfad)
  EndIf

Else

  ShellExecute($MausRechtsDatei,$MausRechtsParameter,$MausRechtsPfad,"",@SW_MINIMIZE)

EndIf

EndFunc


; ========== Doppelklick

Func DoppelKlick()

If $MausDoppelDatei           = "" Then
  return
EndIf

$MausDoppelModus              = StringUpper($MausDoppelModus)

If $MausDoppelModus           = "VERSTECKT" or $MausDoppelModus = "MAXIMIERT" or $MausDoppelModus = "NORMAL" Then

  If $MausDoppelModus         = "VERSTECKT" Then
    ShellExecute($MausDoppelDatei,$MausDoppelParameter,$MausDoppelPfad,"",@SW_HIDE)
  EndIf

  If $MausDoppelModus         = "MAXIMIERT" Then
    ShellExecute($MausDoppelDatei,$MausDoppelParameter,$MausDoppelPfad,"",@SW_MAXIMIZE)
  EndIf

  If $MausDoppelModus         = "NORMAL" Then
    ShellExecute($MausDoppelDatei,$MausDoppelParameter,$MausDoppelPfad)
  EndIf

Else

  ShellExecute($MausDoppelDatei,$MausDoppelParameter,$MausDoppelPfad,"",@SW_MINIMIZE)

EndIf

EndFunc


; ========== Befehl ausfhren

Func BefehlAusfuehren()

If AutoItWinGetTitle()        = "Set" & $INIDatei & "Stop" Then Beenden()

If AutoItWinGetTitle()        = "Set" & $INIDatei & "Pause" Then

  If TrayItemGetState($Pause) = 65 Then    ; Pausiert schon!
    ; Nichts tun
  Else
    Pausieren()
  EndIf

  AutoItWinSetTitle($INIDatei & "Hauptfenster")

EndIf

If AutoItWinGetTitle()        = "Set" & $INIDatei & "Weitermachen" Then

  If TrayItemGetState($Pause) = 68 Then    ; Luft schon!
    ; Nichts tun
  Else
    $LetztesFenster           = "PseudoFenster"    ; damit wieder ausgeblendet wird, wenn aktives Fenster nicht in Liste
    Pausieren()
  EndIf

  AutoItWinSetTitle($INIDatei & "Hauptfenster")

EndIf

If AutoItWinGetTitle()        = "Set" & $INIDatei & "Aktualisieren" Then

  Aktualisieren()

  AutoItWinSetTitle($INIDatei & "Hauptfenster")

EndIf

EndFunc


; ========== Befehl ausfhren


Func Aktualisieren()

  If $AktualisierungErzwingen <> 0 Then
    _IENavigate($oIE,$URL)
    Sleep(333)
    _IEAction($oIE,"refresh")
  Else
    _IENavigate($oIE,$URL,0)
  EndIf

  $Sekunden                    = 0

EndFunc


; ========== Programm-Ende

Func Beenden()

Ausblenden()

Exit

EndFunc


; ========== Damit die Parameter auch beim Herunterfahren gespeichert werden

Func OnAutoItExit()

If $INISchreiben   = 1 Then
  $XP              = $FensterPos[0]
  $YP              = $FensterPos[1]
  IniWrite($INIDatei,"Einstellungen","AbstandOben",  " " & $YP)
  IniWrite($INIDatei,"Einstellungen","AbstandLinks", " " & $XP)
EndIf

EndFunc